/*
 * rawhid_test.c
 *
 *  Created on: 17/ott/2011
 *      Author: napy
 */


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define OS_LINUX

#if defined(OS_LINUX) || defined(OS_MACOSX)
#include <sys/ioctl.h>
#include <termios.h>
#elif defined(OS_WINDOWS)
#include <conio.h>
#endif

#include "hid.h"


int RawHidTest()
{
	int i, r, num;
	char c, buf[64];

	//r = rawhid_open(1, 0x16C0, 0x0480, 0xFFAB, 0x0200);
	r = rawhid_open(1, 0x04D8, 0x3EFF, 0xFF00, 0x0001);
	if (r <= 0) {
		//printf("no rawhid device found\n");
		return -1;
	}

	buf[0] = 248;		// COMMAND GetMasterName

	rawhid_send(0, buf, 64, 100);

	//printf("found rawhid device\n\n");
	//printf("Hit an alphabetic key to send a command to the HID\n\n\n");

	//while (1) {
		// check if any Raw HID packet has arrived
		num = rawhid_recv(0, buf, 64, 220);
		if (num < 0) {
			//printf("\nerror reading, device went offline\n");
			rawhid_close(0);
			return num;
		}
		if (num > 0) {
			//printf("\nrecv %d bytes:\n", num);
			//for (i=0; i<num; i++) {
				//printf("%02X ", buf[i] & 255);
				//if (i % 16 == 15 && i < num-1) printf("\n");
			//}

			//printf("\n\n%s\n", buf + 1);
			//printf("\n\n\n\n");
			return buf[1];
		}

		// check if any input on stdin
		//while ((c = get_keystroke()) >= 32) {
			//printf("\ngot key '%c', sending the GetMasterName command...\n", c);
			//buf[0] = c;
			//for (i=1; i<64; i++) {
			//	buf[i] = 0;

		//buf[0] = 248;		// COMMAND GetMasterName

		//rawhid_send(0, buf, 64, 100);
		//}
	//}
	return -777;
}

#if defined(OS_LINUX) || defined(OS_MACOSX)
// Linux (POSIX) implementation of _kbhit().
// Morgan McGuire, morgan@cs.brown.edu
//static int _kbhit() {
int _kbhit() {
	static const int STDIN = 0;
	static int initialized = 0;
	int bytesWaiting;

	if (!initialized) {
		// Use termios to turn off line buffering
		struct termios term;
		tcgetattr(STDIN, &term);
		term.c_lflag &= ~ICANON;
		tcsetattr(STDIN, TCSANOW, &term);
		setbuf(stdin, NULL);
		initialized = 1;
	}
	ioctl(STDIN, FIONREAD, &bytesWaiting);
	return bytesWaiting;
}
//static char _getch(void) {
char _getch(void) {
	char c;
	if (fread(&c, 1, 1, stdin) < 1) return 0;
	return c;
}
#endif


//static char get_keystroke(void)
char get_keystroke(void)
{
	if (_kbhit()) {
		char c = _getch();
		if (c >= 32) return c;
	}
	return 0;
};

